﻿; Thanks to the original author, Gabe Hiemstra <info@wisdomlib.org>

; 汉语说明
; 1.需要下载并安装Autohotkey。然后双击本脚本。
; 2.#指windows键；+指shift键；!指Alt键；^指ctrl键。使用时，同时按住需要的键。例如输入ā时，需要同时按住windows键与a键。
; 3.在本script中，我只定义了少量的按键组合。可以根据自己的需要，自行设定。
; 4.如果想要设成开机自动启动的话，可以将本脚本放在 C:\ProgramData\Microsoft\Windows\Start Menu\Programs\StartUp 文件夹中。

; Direction
; 1. Download Autohotkey from Internet. Install the exe file. Double click this scipt.
; 2. #=windows key；+=shift key；!=Alt key；^= ctrl key. If you want to print out ā, you should press a and windows key at the same time. and so on.
; 3. I only defined several combinations of keys in this script. You can set your personal key-combinations according to your needs.
; 4. If you want this scipt to run automatically, you can put it in this folder: C:\ProgramData\Microsoft\Windows\Start Menu\Programs\StartUp

; 説明
; 1. Autohotkeyをダウンロードし、exeファイルをインストールしてから、このスクリプトをダブルクリックします。
; 2. #=windowsキー；+=shiftキー；!=Altキー；^= ctrlキー。入力するときにはキーを同時に押します。例えば、āを入力する際にはwindowsキーとaのキーを同時に押します。
; 3. このスクリプトでは、いくつかのキーの組み合わせのみを指定しています。ご自身の必要に応じて、キーの組み合わせを設定してください。
; 4. このスクリプトを自動で動くようにしたい場合は、C:\ProgramData\Microsoft\Windows\Start Menu\Programs\StartUp に入れてください。


#a:: PutUni("ā") return
+#A:: PutUni("Ā") return
!a:: PutUni("á") return
!^a:: PutUni("à") return

#i:: PutUni("ī") return
+#I:: PutUni("Ī") return
!i:: PutUni("í") return
!^i:: PutUni("ì") return

#u:: PutUni("ū") return
+#U:: PutUni("Ū") return
!u:: PutUni("ú") return
!^u:: PutUni("ù") return

#r:: PutUni("ṛ") return
+#R:: PutUni("Ṛ") return
#f:: PutUni("ṝ") return
+#f:: PutUni("Ṝ") return

#e:: PutUni("ē") return
+#e:: PutUni("Ē") return
!e:: PutUni("é") return
+!e:: PutUni("É") return
!^e:: PutUni("è") return
+!^e:: PutUni("È") return

#o:: PutUni("ö") return
+#o:: PutUni("Ö") return
!o:: PutUni("ó") return
!^o:: PutUni("ò") return

#d:: PutUni("ḍ") return
+#D:: PutUni("Ḍ") return

#h:: PutUni("ḥ") return
+#H:: PutUni("Ḥ") return

#k:: PutUni("ḳ") return
+#K:: PutUni("Ḳ") return
!l:: PutUni("ḷ") return
+!L:: PutUni("Ḷ") return

#m:: PutUni("ṃ") return
+#M:: PutUni("Ṃ") return
!m:: PutUni("ṁ") return
!+M:: PutUni("Ṁ") return
#n:: PutUni("ṇ") return
+#N:: PutUni("Ṇ") return
#g:: PutUni("ṅ") return
+#g:: PutUni("Ṅ") return
#j:: PutUni("ñ") return
+#j:: PutUni("Ñ") return
#p:: PutUni("√") return

#s:: PutUni("ṣ") return
+#S:: PutUni("Ṣ") return
#z:: PutUni("ś") return
+#z:: PutUni("Ś") return
#t:: PutUni("ṭ") return
+#T:: PutUni("Ṭ") return


; Other / Misc / Typography
!^.:: PutUni("…") return
!-:: PutUni("–") return
!^-:: PutUni("—") return
!^4:: PutUni("§") return
!1:: PutUni("‘") return
!2:: PutUni("’") return
!^1:: PutUni("“") return
!^2:: PutUni("”") return
+!1:: PutUni("½") return
+!2:: PutUni("¼") return
+!3:: PutUni("¾") return
!^=:: PutUni("±") return
!<:: PutUni("←") return
!>:: PutUni("→") return
!?:: PutUni("↔") return
!4:: PutUni("¬") return
!5:: PutUni("∧") return
!6:: PutUni("∨") return
!7:: PutUni("∩") return
!8:: PutUni("∪") return
!9:: PutUni("∀") return
!0:: PutUni("∃") return
!c:: PutUni("├") return

;Paste UTF8 string (Hex encoded or not) as unicode.
;If you don't use Hex encoding, you must save your script as UTF8
PutUni(DataIn)
{
   SavedClip := ClipBoardAll

   ClipBoard =
   If RegExMatch(DataIn, "^[0-9a-fA-F]+$")
   {
      Loop % StrLen(DataIn) / 2
         UTF8Code .= Chr("0x" . SubStr(DataIn, A_Index * 2 - 1, 2))
   }
   Else
      UTF8Code := DataIn

   Send %UTF8Code%

   ; ! DEPRECATED
   ; Abby fineread pro has the bad habit of adding an extra \newline when pasting stuff.
   ; this will detect abbyy, and sends an extra backspace after using a hotkey with this script
   ;WinGetTitle, Title, A
   ;if RegExMatch(Title, "FineReader")
   ;{
   ;    Send {backspace}
   ;}

   Sleep 200 ;Generous, less wait or none will often work.
   ClipBoard := SavedClip
   return
}